﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Topic04
{
    public partial class Form1 : Form
    {
        private int threadCount = 0;
        public Form1()
        {
            InitializeComponent();
            ThreadControlSingleton.Instance.Proc = new ThreadControlSingleton.ProcDelegate(TestProc);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ThreadControlSingleton.Instance.ThreadStart();
        }

        private void TestProc()
        {
            // メインスレッド以外は再呼び出し
            if (this.InvokeRequired)
            {
                this.Invoke((MethodInvoker)delegate() { TestProc(); });
                return;
            }
            threadCount++;
            label1.Text = threadCount + "回スレッドを動かしました。";
        }
    }
}